package com.huiju.miniapp.common;

import cn.binarywang.wx.miniapp.api.WxMaService;
import cn.binarywang.wx.miniapp.api.impl.WxMaServiceImpl;
import cn.binarywang.wx.miniapp.config.WxMaInMemoryConfig;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huiju.miniapp.entity.MiniappConfiger;
import com.huiju.miniapp.service.IMiniappConfigerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class InitWxMaService {
    private static Map<String, WxMaService> maServices = new HashMap<>();

    @Autowired
    IMiniappConfigerService miniappConfigerService;

    public static WxMaService getMaService(String appid) {
        return maServices.get(appid);
    }

    @PostConstruct
    public void init() {
        QueryWrapper<MiniappConfiger> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("state", 1);
        List<MiniappConfiger> configs = miniappConfigerService.list();
        if (null == configs || configs.size() == 0) return;

        for (MiniappConfiger config: configs) {
            initService(config);
        }
    }

    public static WxMaService initService(MiniappConfiger config) {
        WxMaInMemoryConfig wxMaInMemoryConfig = new WxMaInMemoryConfig();
        wxMaInMemoryConfig.setAppid(config.getAppid());
        wxMaInMemoryConfig.setSecret(config.getSecret());
        wxMaInMemoryConfig.setToken(config.getToken());
        wxMaInMemoryConfig.setAesKey(config.getAesKey());
        wxMaInMemoryConfig.setMsgDataFormat(config.getMsgDataFormat());

        WxMaService service = new WxMaServiceImpl();
        service.setWxMaConfig(wxMaInMemoryConfig);

        maServices.put(config.getAppid(), service);
        return service;
    }

    public static WxMaService resetService(MiniappConfiger config) {
        maServices.remove(config.getAppid());
        return initService(config);
    }
}
