package com.huiju.miniapp.common;

import cn.binarywang.wx.miniapp.bean.WxMaTemplateData;
import cn.binarywang.wx.miniapp.bean.WxMaTemplateMessage;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;


public class TemplateMsgUtil {

    public static WxMaTemplateMessage create(String tplId, String formId, String toUser, String page, List<Object> data) {
        if (null == data || data.size() == 0) return null;
        if (null == tplId || null == formId || null == toUser) return null;

        List<WxMaTemplateData> tplData = new ArrayList<>();

        for (int i = 1; i <= tplData.size(); i ++) {
            Object o = data.get(i - 1);

            String val = null;
            String color = "#173177";
            if (o instanceof String ) {
                val = (String) o;
            } else if (o instanceof Map) {
                val = (String) ((Map) o).get("value");

                String colour = (String) ((Map) o).get("color");
                if (null != colour && colour.startsWith("#")) {
                    color = colour;
                }
            } else {
                throw new IllegalArgumentException("发送内容暂时不支持 " + o.getClass() + "格式数据");
            }

            String name = "keyword" + i;
            tplData.add(new WxMaTemplateData(name, val, color));
        }

        return WxMaTemplateMessage.builder().templateId(tplId).formId(formId).page(page).data(tplData).toUser(toUser).build();
    }
}
