package com.huiju.miniapp.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.miniapp.common.InitWxMaService;
import com.huiju.miniapp.common.ResponseBean;
import com.huiju.miniapp.entity.MiniappConfiger;
import com.huiju.miniapp.mapper.MiniappConfigerMapper;
import com.huiju.miniapp.service.IMiniappConfigerService;
import org.apache.http.HttpStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-06-05
 */
@Service
public class MiniappConfigerServiceImpl extends ServiceImpl<MiniappConfigerMapper, MiniappConfiger> implements IMiniappConfigerService {
    @Autowired
    MiniappConfigerMapper miniappConfigerMapper;

    @Override
    public ResponseBean registe(MiniappConfiger miniappConfiger) {
        String appid = miniappConfiger.getAppid();
        if (null == appid || "".equals(appid.trim())) {
            return ResponseBean.error("小程序 AppID 不能为空", HttpStatus.SC_BAD_REQUEST);
        }

        // 印象中 secret 必须长度 43
        if (null == miniappConfiger.getSecret() || miniappConfiger.getSecret().length() < 5) {
            return ResponseBean.error("小程序 secret 参数为空或非法", HttpStatus.SC_BAD_REQUEST);
        }


        MiniappConfiger config = miniappConfigerMapper.selectById(appid);
        if (null != config) {
            return ResponseBean.error("请不要重复注册小程序服务", HttpStatus.SC_BAD_REQUEST);
        }

        miniappConfiger.setState(1);
        miniappConfiger.setCreateDate(LocalDateTime.now());
        int succes = miniappConfigerMapper.insert(miniappConfiger);
        if (succes < 1) {
            return ResponseBean.error("服务注册失败", HttpStatus.SC_INTERNAL_SERVER_ERROR);
        }

        InitWxMaService.initService(miniappConfiger);
        return ResponseBean.success(miniappConfiger);
    }
}
